/****************************************************************************
** $Id: qapplicationwindow.h,v 1.7 2003/01/06 10:18:52 rom_vinot Exp $
**
** Copyright (C) 1992-2000 Trolltech AS.  All rights reserved.
**
** This file is part of an example program for Qt.  This example
** program may be used, distributed and modified without limitation.
**
*****************************************************************************/

#ifndef APPLICATION_H
#define APPLICATION_H


#ifdef _WIN32

#pragma warning (disable : 4786)

#endif


#include <qmainwindow.h>

#include "qinterfaceimpl.h"
#include "qthemeengine.h"

class QMultiLineEdit;
class QToolBar;
class QString;

class ApplicationWindow: public QMainWindow
{
    Q_OBJECT
public:
    ApplicationWindow();
    ~ApplicationWindow();

    QInterfaceImpl *getMainWindow();
protected:
    void closeEvent( QCloseEvent* );

private slots:
    void newGame();
    void load();
    void load( const char *fileName );
    void save();
    void save(QString filename);
    void quicksave();
    void quickload();

    void printLevelInfo();
    void switchview();
    void changeTheme(int themeId);
    void useRandomGround(void);
    void viewObjective(void);

    void rulebook();
    void about();
    void aboutQt();

    void redo();

    void boardUp();
    void boardDown();
    void boardLeft();
    void boardRight();
private:
    QInterfaceImpl *main;
    QToolBar *fileTools;
    QString quickfile;

    QThemeEngine *themeEngine;
    QPopupMenu *themes;
    
    QPopupMenu *view;
    int buttonRandomGround;
    int buttonObjective;

    int idNewButton;
    map<int, string> themesId;
    map<string, int> themesString;
};

#endif
